
var util;
util = require('./util');
exports.render = function (ast) {
  var buffer, indent, mode, renderSpan, renderNewline, increaseIndent, decreaseIndent, render;
  buffer = '';
  indent = -1;
  mode = 'line';
  renderSpan = function (text) {
    /* console.log */;
    return buffer = '' + buffer + text;
  };
  renderNewline = function () {
    renderSpan('\n');
    if (indent === 0) {
      renderSpan('\n');
    } else {
    }
    return renderSpan(util.spaces(indent * 2));
  };
  increaseIndent = function () {
    return indent = indent + 1;
  };
  decreaseIndent = function () {
    return indent = indent - 1;
  };
  render = function (node, index, len, inline, level, lucky) {
    var noLuckyChild;
    /* console.log */;
    switch (util.type(node)) {
      case 'string':
        switch (mode) {
          case 'line':
            renderNewline();
            renderSpan(', ');
            renderSpan(util.markToken(node));
            mode = 'text';
            break;
          case 'text':
            renderSpan(' ');
            renderSpan(util.markToken(node));
            break;
          case 'start':
            renderSpan(util.markToken(node));
            mode = 'text';
            break;
        }
        break;
      case 'array':
        switch (mode) {
          case 'line':
            renderNewline();
            mode = 'start';
            increaseIndent();
            noLuckyChild = true;
            node.forEach(function (child, i) {
              render(child, i, node.length, i === 0, level + 1, true, noLuckyChild);
              if (util.isArray(child)) {
                return noLuckyChild = false;
              } else {
              }
            });
            decreaseIndent();
            mode = 'line';
            break;
          case 'text':
            if ((index + 1) === len) {
              renderSpan(' $');
              noLuckyChild = true;
              node.forEach(function (child, i) {
                render(child, i, node.length, i === 0, level + 1, noLuckyChild);
                if (util.isArray(child)) {
                  return noLuckyChild = false;
                } else {
                }
              });
              mode = 'line';
            } else {
              if ((util.isPlain(node)) && lucky) {
                renderSpan(' (');
                mode = 'start';
                node.forEach(function (child, i) {
                  return render(child, i, node.length, i === 0, level + 1, true);
                });
                renderSpan(')');
                mode = 'text';
              } else {
                renderNewline();
                mode = 'start';
                increaseIndent();
                noLuckyChild = true;
                node.forEach(function (child, i) {
                  render(child, i, node.length, i === 0, level + 1, noLuckyChild);
                  if (util.isArray(child)) {
                    return noLuckyChild = false;
                  } else {
                  }
                });
                decreaseIndent();
                mode = 'line';
              }
            }
            break;
          case 'start':
            if (inline && (level > 1)) {
              renderSpan('(');
              mode = 'start';
              node.forEach(function (child, i) {
                return render(child, i, node.length, true, level + 1, false);
              });
              renderSpan(')');
              mode = 'text';
            } else {
              increaseIndent();
              noLuckyChild = true;
              node.forEach(function (child, i) {
                render(child, i, node.length, i === 0, level + 1, true);
                if (util.isArray(child)) {
                  return noLuckyChild = false;
                } else {
                }
              });
              decreaseIndent();
              mode = 'line';
            }
            break;
        }
        break;
    }
    return buffer;
  };
  if (!(ast.every(util.isArray))) {
    throw new Error('Cirru AST uses nested arrays');
  } else {
  }
  return render(ast, 0, 1, false, 0, false);
};
